#include <cstring>
#include "SKINI2.msg"
#include "WvOut.h"
#include "Instrmnt.h"
#include "JCRev.h"
#include "Voicer.h"
#include "Skini.h"
//#include "Echo.h"
#include "RtAudio.h"
#include "Mutex.h"
#include <cstring>
#include "Instrmnt.h"
#include "FileWvOut.h"
#include "Messager.h"
#include "TX81Z.h"
#include "Instrmnt.h"
#include <stdlib.h>
#include "SineWave.h"
#include <signal.h>
#include <iostream>
#include <algorithm>
#include <cmath>
using std::min;
bool done;
static void finish(int ignore)
{ 
  done = true; 
}
using namespace stk;
struct TickData 
{
  WvOut **wvout;
  Instrmnt **instrument;
  Voicer *voicer;
  JCRev reverb;
  //Echo echo; //t3g
  Messager messager;
  Skini::Message message;
  StkFloat volume;
  StkFloat t60;
  unsigned int nWvOuts;
  int nVoices;
  int currentVoice;
  int channels;
  int counter;
  bool realtime;
  bool settling;
  bool haveMessage;
  int frequency;
  TickData()
    : wvout(0),        
      instrument(0),   
      voicer(0),         
      volume(1.0),   
      t60(0.75),
      nWvOuts(0),      
      nVoices(1),      
      currentVoice(0),   
      channels(2),   
      counter(0),
      realtime(false), 
      settling(false), 
      haveMessage(false) {}
};
#define DELTA_CONTROL_TICKS 1 
void processMessage( TickData* data )
{
  register StkFloat value1 = data->message.floatValues[0];
  register StkFloat value2 = data->message.floatValues[1];
  switch( data->message.type ) {
  case __SK_Exit_:
    if ( data->settling == false )
      goto settle;
    done = true;
    return;
  case __SK_NoteOn_:
    if ( value2 > 0.0 ) 
    {
      //oStream_ << "noteOn in demo.cpp";
      data->voicer->noteOn( value1, value2 );
      break;
    }
    
  case __SK_NoteOff_:
    data->voicer->noteOff( value1, value2 );
    break;
  case __SK_ControlChange_:
    if (value1 == 4040.0)
      data->reverb.setEffectMix(value2  * 0.01);
    else if (value1 == 4041.0)
      data->reverb.setT60(value2);
    //else if (value1 == 4043.0)
    //  data->echo.setDelay(1292*value2*0.5);
    else if (value1 == 7.0)
      data->volume = value2 * ONE_OVER_128;
    else if (value1 == 49.0)
      data->voicer->setFrequency( value2 );
    else if (value1 == 50.0)
      data->voicer->controlChange( 128, value2 );
    else if (value1 == 51.0)
      data->frequency = data->message.intValues[1];
    else if (value1 == 52.0) 
    {
      data->frequency += ( data->message.intValues[1] << 7 );
      StkFloat note = 12.0 * log( data->frequency / 220.0 ) / log( 2.0 ) + 57.0;
      data->voicer->setFrequency( note );
    }
    else
      data->voicer->controlChange( (int) value1, value2 );
    break;
  case __SK_AfterTouch_:
    data->voicer->controlChange( 128, value1 );
    break;
  case __SK_PitchChange_:
    data->voicer->setFrequency( value1 );
    break;
  case __SK_PitchBend_:
    data->voicer->pitchBend( value1 );
    break;
  case __SK_Volume_:
    data->volume = value1 * ONE_OVER_128;
    break;
  case __SK_ProgramChange_:
    if ( data->currentVoice == (int) value1 )
      break;
    if ( data->settling == false )
      goto settle;
    for ( int i=0; i<data->nVoices; i++ ) 
    {
      data->voicer->removeInstrument( data->instrument[i] );
      delete data->instrument[i];
      data->currentVoice = 0;
      if ( data->currentVoice < 0 )
        data->currentVoice = 0;
      data->voicer->addInstrument( data->instrument[i] );
      data->settling = false;
    }
  }
  data->haveMessage = false;
  return;
 settle:
  data->voicer->silence();
  data->counter = (int) (0.3 * data->t60 * Stk::sampleRate());
  data->settling = true;
}
int tick( void *outputBuffer, void *inputBuffer, unsigned int nBufferFrames,
          double streamTime, RtAudioStreamStatus status, void *dataPointer )
{
  TickData *data = (TickData *) dataPointer;
  register StkFloat sample, *samples = (StkFloat *) outputBuffer;
  int counter, nTicks = (int) nBufferFrames;
  while ( nTicks > 0 && !done ) 
  {
  
    if ( !data->haveMessage ) 
    {
      data->messager.popMessage( data->message );
      if ( data->message.type > 0 ) 
      {
        data->counter = (long) (data->message.time * Stk::sampleRate());
        data->haveMessage = true;
      }
      else
        data->counter = DELTA_CONTROL_TICKS;
    }
    counter = min( nTicks, data->counter );
    data->counter -= counter;
    for ( int i=0; i<counter; i++ ) 
    {
      sample = data->volume * data->reverb.tick( data->voicer->tick() );
      //sample += 0.9 * data->volume * data->reverb.tick( data->echo.tick( data->voicer->tick() ) );
      //sample += 0.8 * data->volume * data->reverb.tick( data->echo.tick( data->echo.tick( data->voicer->tick() ) ) );
      //sample += 0.7 * data->volume * data->reverb.tick( data->echo.tick( data->echo.tick( data->echo.tick( data->voicer->tick() ) ) ) );
      for ( unsigned int j=0; j<data->nWvOuts; j++ )
        data->wvout[j]->tick(sample);
      if ( data->realtime )
        for ( int k=0; k<data->channels; k++ ) *samples++ = sample;
      nTicks--;
    }
    if ( nTicks == 0 )
      break;
    if ( data->haveMessage )
      processMessage( data );
  }
  return 0;
}
int main( int argc, char *argv[] )
{
  TickData data;
  int i;
  RtAudio dac;
  Stk::setSampleRate( 44100.0 );
  Stk::setRawwavePath( "../../rawwaves/" );
  Stk::showWarnings( true );
  data.nWvOuts = 1;
  data.wvout = (WvOut **) calloc( data.nWvOuts, sizeof(WvOut *) );
  data.nVoices = 3;
  data.instrument = (Instrmnt **) calloc( data.nVoices, sizeof(Instrmnt *) );
  data.currentVoice = 0;
  data.instrument[0] = new TX81Z;
  if ( data.currentVoice < 0 ) 
  {
    free( data.wvout );
    free( data.instrument );
    exit(0);
  }
  for ( i=1; i<data.nVoices; i++ )
    data.instrument[i] = new TX81Z;
  data.voicer = (Voicer *) new Voicer( 0.2 );
  for ( i=0; i<data.nVoices; i++ )
    data.voicer->addInstrument( data.instrument[i] );
  data.realtime = true;//
  //parseArgs( argc, argv, data.wvout, data.messager );
  data.messager.startStdInput();
  data.messager.startMidiInput();
  char fileName[256];
  strcpy(fileName,"out.wav");
  data.wvout[0] = new FileWvOut(fileName, 1, FileWrite::FILE_WAV );
  RtAudioFormat format = ( sizeof(StkFloat) == 8 ) ? RTAUDIO_FLOAT64 : RTAUDIO_FLOAT32;
  RtAudio::StreamParameters parameters;
  parameters.deviceId = dac.getDefaultOutputDevice();
  parameters.nChannels = data.channels;
  unsigned int bufferFrames = RT_BUFFER_SIZE;
  dac.openStream( &parameters, NULL, format, (unsigned int)Stk::sampleRate(), &bufferFrames, &tick, (void *)&data );
  data.reverb.setT60( 4 * data.t60 );
  data.reverb.setEffectMix(0.0);
  //data.echo.setDelay(1292*10);
  //data.echo.setMaximumDelay(44100);
  (void) signal(SIGINT, finish);
  dac.startStream();
  while ( !done ) 
  {
    Stk::sleep( 200 );
  }
 dac.closeStream();
  for ( i=0; i<(int)data.nWvOuts; i++ )
    delete data.wvout[i];
  free( data.wvout );
  delete data.voicer;
  for ( i=0; i<data.nVoices; i++ )
    delete data.instrument[i];
  free( data.instrument );
  std::cout << "\nStk demo finished ... goodbye.\n\n";
  return 0;
}
