#!  python < python/buildup.ski.py | ./demo
print "ControlChange  0 1 4999  1" # algorithm 1 thru 8

#    -----------------------------------------------
#    Algorithm Structures:
#    -----------------------------------------------
#    Carrier = first factor of each first level term
#    Modulation is by right-multiplication
#    FeedBack In  = ]
#    FeedBack Out = [
#    -----------------------------------------------
#    1 - 012[3]
#    2 - 01(2+[3])
#    3 - 0(12+[3])
#    4 - 0(1+2[3])
#    5 - 01+2[3]
#    6 - 0[3]+1[3]+2[3]
#    7 - 0+1+2[3]
#    8 - 0+1+2+[3]
#    -----------------------------------------------

# operator 0
print "ControlChange  0 1 4000 32" # gain
print "ControlChange  0 1 4001  1" # A
print "ControlChange  0 1 4002 20" # D
print "ControlChange  0 1 4003  0" # S
print "ControlChange  0 1 4004  1" # R
print "ControlChange  0 1 4005  0" # ratio
print "ControlChange  0 1 4006  0" # detune

# operator 1
print "ControlChange  0 1 4010  8" # gain
print "ControlChange  0 1 4011  1" # A
print "ControlChange  0 1 4012 20" # D
print "ControlChange  0 1 4013  0" # S
print "ControlChange  0 1 4014  1" # R
print "ControlChange  0 1 4015  1" # ratio
print "ControlChange  0 1 4016  0" # detune

# operator 2
print "ControlChange  0 1 4020 32" # gain
print "ControlChange  0 1 4021  1" # A
print "ControlChange  0 1 4022 20" # D
print "ControlChange  0 1 4023  0" # S
print "ControlChange  0 1 4024  1" # R
print "ControlChange  0 1 4025  2" # ratio
print "ControlChange  0 1 4026  0" # detune

# operator 3
print "ControlChange  0 1 4030  8" # gain
print "ControlChange  0 1 4031  1" # A
print "ControlChange  0 1 4032 20" # D
print "ControlChange  0 1 4033  0" # S
print "ControlChange  0 1 4034  1" # R
print "ControlChange  0 1 4035  4" # ratio
print "ControlChange  0 1 4036  0" # detune

# general
print "ControlChange  0 1 4040  0" # reverb level
print "ControlChange  0 1 4041  4" # reverb tail
print "ControlChange  0 1 4042 40" # master level
print "ControlChange  0 1 4043 46" # echo length : not active

for i in range(192):
  print 'ControlChange  0.0 1 4999 '+ str(i%8+1)                        # cycling thru algorithms 1 thru 8
  print 'ControlChange  0.0 1 4040 '+ str(i/16.0)                       # slowly raise reverb level
  print 'ControlChange  0.0 1 4041 '+ str(1.0+3.0*i*i/64.0/64.0)        # slowly lengthen reverb tail
  print   "NoteOn  "+str(0.125*60.0/128.0)+" 1 "+str(36.+i/8.)+" 100"   # slowly raise pitch
  if i<191:
    print "NoteOff "+str(0.375*60.0/128.0)+" 1 "+str(36.+i/8.)+" 100"
  else:
    print "NoteOff "+str(16*60.0/128.0)   +" 1 "+str(36.+i/8.)+" 100"   # allow for long reverb tail at the end
for i in range(15):
  print "ControlChange  1.0  1 4042 " + str(40.0*(1.0-i/16.0))
    
  
